/***********************************************************************
* cpiud132.h
*
* CPI-UD132 Windows API
* Copyright (C) CPI Technologies, Inc.
***********************************************************************/

#ifndef CPIUD132_H      /*[*/
#define CPIUD132_H      1

#ifdef __cplusplus
extern  "C"
{
#endif

/*-----------------------------------------------------------------
// 荞݃bZ[WID
//---------------------------------------------------------------*/

#define UD132_WM_TRIG                   0x2000      /* bZ[WID */

/*-----------------------------------------------------------------
// G[R[h
//---------------------------------------------------------------*/
#define UD132_SUCCESS                   0   /* I*/
                                            /* Windows G[ */
#define UD132_ERR_SYSTEM                1   /* GetLastError R[ */
#define UD132_ERR_NO_DEVICE             2   /* gp\ȃfoCXȂ */
#define UD132_ERR_IN_USE                3   /* wfoCX͎gpł */
#define UD132_ERR_INVALID_DEVICENO      4   /* Ș_foCXԍ */
#define UD132_ERR_INVALID_ARGUMENT      5   /* Ȉ */
#define UD132_ERR_INVALID_PORT          6   /* Ș_|[g */
#define	UD132_ERR_TRG_DATA_INVALID      7   /*  |[gĎvf[^Ȃ */
                                            /* DLL [hs */
#define UD132_ERR_DLL                   ( ~0UL )

/*-----------------------------------------------------------------
// ̑
//---------------------------------------------------------------*/
#define UD132_MAX_DEVICES               16
#define UD132_DEVICE_AUTO               ( ( unsigned short )~0 )

/*-----------------------------------------------------------------
// _|[gԍ
//---------------------------------------------------------------*/
#define UD132_PORT_A                    0    /* OUT|[g1 */
#define UD132_PORT_B                    1    /* OUT|[g2 */
#define UD132_PORT_C                    2    /* IN |[g1 */
#define UD132_PORT_D                    3    /* IN |[g2 */
#define UD132_MAX_PORTS                 4    /* S|[g */

/*-----------------------------------------------------------------
// jbg^Cv
//---------------------------------------------------------------*/
#define TYPE_ZD132                      1
#define TYPE_ZD232                      2
#define TYPE_ZD332                      3
#define TYPE_UD132                      9
#define TYPE_UD232                      10
#define TYPE_UD332                      11

/*-----------------------------------------------------------------
// tB^C^[o萔
//---------------------------------------------------------------*/
#define UD132_FILTER_INTERVAL_STOP      0
#define UD132_FILTER_INTERVAL_1260      1
#define UD132_FILTER_INTERVAL_2520      2
#define UD132_FILTER_INTERVAL_5040      3
#define UD132_FILTER_INTERVAL_10080     4
#define UD132_FILTER_INTERVAL_20160     5

/*-----------------------------------------------------------------
// EIb`hbNC^[o萔
//---------------------------------------------------------------*/
#define UD132_WDT_INTERVAL_STOP         0
#define UD132_WDT_INTERVAL_126          1
#define UD132_WDT_INTERVAL_252          2
#define UD132_WDT_INTERVAL_504          3
#define UD132_WDT_INTERVAL_1008         4
#define UD132_WDT_INTERVAL_2016         5

/*-----------------------------------------------------------------
// EIb`hbNJE^̏
//---------------------------------------------------------------*/
#define UD132_WDT_FLAG_OFF              0    /* EIb`hbN܂́ANO */
#define UD132_WDT_FLAG_ON               1    /* EIb`hbNN */

/*-----------------------------------------------------------------
// foCX
//---------------------------------------------------------------*/

#define UD132_CCH_VEN                   8
#define UD132_CCH_DEV                   16
#define UD132_CCH_VER                   4

typedef struct
{
    unsigned short  cbCdb;              /* R}h\̂̃oCg */
    unsigned short  cbSdb;              /* Xe[^X\̂̃oCg */
    unsigned long   cbBuff;             /* obt@̃oCg */
    char    sVen[ UD132_CCH_VEN ];      /* Җ */
    char    sDev[ UD132_CCH_DEV ];      /* i */
    char    sVer[ UD132_CCH_VER ];      /* t@[EFAo[W */
} TUD132DI, *PUD132DI;

/*-----------------------------------------------------------------
// |[gĎ
//---------------------------------------------------------------*/

/* [h */
#define UD132_MON_NONE                  0   /* ĎȂ */
#define UD132_MON_ALT                   1   /* Ώۃrbgɕω */
#define UD132_MON_AND                   2   /* ΏۃrbgSv */
#define UD132_MON_OR                    3   /* Ώۃrbgv */

typedef struct  /* |[gĎݒ̍\ */
{
    unsigned char   bMode;      /* [h */
    unsigned char   bMask;      /* ĎΏۃrbg}XN */
    unsigned char   bData;      /* f[^ */
} TUD132TC, *PUD132TC;

#ifdef  WIN32   /*[*/

/*-----------------------------------------------------------------
// Gg
//---------------------------------------------------------------*/

        /* DLL [h */
BOOL WINAPI Ud132DllOpen( void );
        /* DLL  */
BOOL WINAPI Ud132DllClose( void );
        /* ŌɔG[̃R[h擾 */
DWORD WINAPI Ud132GetLastError( WORD pwLogDevice );
        /* DLLAhCõo[W擾 */
BOOL WINAPI Ud132GetVersion( PDWORD pdwDllVersion, PDWORD pdwDriverVersion );
        /* Cӂ̃foCX̎gp錾 */
BOOL WINAPI Ud132Create( PWORD pwLogDevice, HWND hwnd, UINT uWMCode );
        /* gp̃foCX */
BOOL WINAPI Ud132Close( WORD wLogDevice );
        /* foCX擾 */
BOOL WINAPI Ud132GetDevInfo( WORD wLogDevice, PUD132DI pDevInfo );
        /* [^[XCb`̒l擾 */
BOOL WINAPI Ud132GetSwitchValue( WORD wLogDevice, PDWORD pdwSwitchValue );
        /* jbg^Cv擾 */
BOOL WINAPI Ud132GetUnitType( WORD wLogDevice, PDWORD pdwUnitTypeValue );
        /* Cӂ̃|[gf[^ */
BOOL WINAPI Ud132InPort( WORD wLogDevice, DWORD dwLogPort, PBYTE pbInValue );
        /* Cӂ̃|[gփf[^o */
BOOL WINAPI Ud132OutPort( WORD wLogDevice, DWORD dwLogPort, BYTE bOutValue );

        /* EIb`hbN̐ݒ */
BOOL WINAPI Ud132SetWdt( WORD wLogDevice, BYTE bWdtValue );
        /* EIb`hbN̊Jn */
BOOL WINAPI Ud132ResetWdt( WORD wLogDevice );
        /* EIb`hbNo͐ݒ */
BOOL WINAPI Ud132SetDefaultOutput( WORD wLogDevice, DWORD dwLogPort, BYTE bDefaultValue );
        /* EIb`hbNtO */
BOOL WINAPI Ud132GetWdtStatus( WORD wLogDevice, PBYTE pbWdtStatus );

        /* |[gĎl̐ݒ */
BOOL WINAPI Ud132SetTrgCond( WORD wLogDevice, DWORD dwLogPort, PUD132TC pTrgCond );

        /* tB^̃TCNAv񐔒l̐ݒ */
BOOL WINAPI Ud132SetFilter( WORD wLogDevice, BYTE bInterval, BYTE bCount );

#endif  /*] WIN32 */

#ifdef __cplusplus
}
#endif

#endif  /*] CPIUD132_H */
