/*============================================================================
//  cpiud132s.c
//
//  CPI-UD132
//  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
//
//  Copyright (C) CPI Technologies, Inc.
//==========================================================================*/
#define STRICT
#include <windows.h>
#include <tchar.h>
#include "cpiud132.h"

const TCHAR szTitle[] = _T("Sample");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD iDev);
static  LPCTSTR str_err( ULONG iError );

/*============================================================================
//  vO̊Jn
//===========================================================================*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    WORD    iDev;               /* foCX̘_Xbgԍi[ */
    ULONG   dDll;               /* Dllo[W */
    ULONG   dDrv;               /* hCo[W */

    TUD132DI    di;             /* foCX̍\̕ϐ */
    ULONG   dVal;               /* [^[XCb`̒l */

    BYTE  cbDat;                /* o̓f[^ϐ */
    BYTE bInterval;             /* ̓tB^@\ ̐ݒ */
    BYTE bCount;                /* ̓tB^@\ v񐔂̐ݒ */

    ULONG   get_err;

    TCHAR szBuf[512];

    ( void )hInstance;
    ( void )hPrevInstance;
    ( void )lpCmdLine;
    ( void )nCmdShow;

    /*-------------------------------------------------
    // DLL ̎gp錾
    //-----------------------------------------------*/
    if ( ! Ud132DllOpen() )
    {
        ResultMessage(_T("Ud132DllOpen error.\n"));
        get_err = GetLastError();
        wsprintf(szBuf, _T("Windows GetLastError\n\n") _T("Error code: %08lxh"),get_err);
        MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
        return 1;               /* ud132.dll ̃[hɎs܂ */
    }
    ResultMessage(_T("Ud132DllOpen succeeded.\n"));

    /*-------------------------------------------------
    // o[Wԍ\
    // CPI-UD132 DLL,hCo[̃o[Wԍ擾
    //-----------------------------------------------*/
    if ( ! Ud132GetVersion( &dDll, &dDrv ) )
    {
        ResultMessage(_T("Ud132GetVersion failed.\n\n"));
        get_err = GetLastError();
        wsprintf(szBuf, _T("Windows GetLastError\n\n") _T("Error code: %08lxh"),get_err);
        MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
        return 1;
    }
    wsprintf(szBuf, _T("GetVersion\n")
                    _T("DLL    Version\t: %08lxh\n")
                    _T("Driver Version\t: %08lxh"),
                    dDll,
                    dDrv);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // CPI-UD132̎gp錾
    //-----------------------------------------------*/
    iDev = UD132_DEVICE_AUTO;           /* gp̃foCXT܂B*/
    if ( ! Ud132Create( &iDev, NULL, 0 ) )
    {
        ErrorMessage(UD132_DEVICE_AUTO);
        get_err = GetLastError();
        wsprintf(szBuf, _T("Windows GetLastError\n\n") _T("Error code: %08lxh"),get_err);
        MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
        return 1;
    }
    wsprintf(szBuf, _T("CPI-UD132 Created\n\n")
            _T("Device # is: %2d"), iDev);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // \[X
    //-----------------------------------------------*/
    if ( ! Ud132GetDevInfo( iDev, &di ) )
    {
        ErrorMessage(iDev);
        return 1;
    }
    wsprintf(szBuf, _T("GetDevInfo\n\n")
                    _T("cbCdb : %u\n" )
                    _T("cbSdb : %u\n" )
                    _T("cbBuff: %lu\n" )
                    _T("sVen  : %.8hs\n" )
                    _T("sDev  : %.16hs\n" )
                    _T("sVer  : %.4hs\n\n" ),
                    di.cbCdb,
                    di.cbSdb,
                    di.cbBuff,
                    di.sVen,
                    di.sDev,
                    di.sVer);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // [^[XCb`̒l擾
    //-----------------------------------------------*/
    if ( ! Ud132GetSwitchValue( iDev, &dVal ) )
    {
        ErrorMessage(iDev);
        return 1;
    }
    wsprintf(szBuf, _T("GetSwitchValue\n\n")
                    _T("SW Val=0x%lX.\n"), dVal );
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // Port A 0xAÃf[^o
    //-----------------------------------------------*/
    ResultMessage(_T("Port A փf[^o (0xAA)"));
    cbDat = (BYTE)0xAA;           /* o̓f[^Zbg 0xAAh */
    if ( ! Ud132OutPort( iDev, UD132_PORT_A, cbDat ) )
    {
        ErrorMessage(iDev);
        return 1;
    }
    wsprintf(szBuf, _T("o͊\n")
                    _T("Port A Out Data: %02xh"), cbDat);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // Port A 0x00̃f[^o
    //-----------------------------------------------*/
    ResultMessage(_T("Port A փf[^o (0x00)"));
    cbDat = (BYTE)0x00;         /* o̓f[^Zbg 0x00h */
    if ( ! Ud132OutPort( iDev, UD132_PORT_A, cbDat ) )
    {
        ErrorMessage(iDev);
        return 1;
    }
    wsprintf(szBuf, _T("o͊\n")
                    _T("Port A Out Data: %02xh"), cbDat);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // Port B 0x55̃f[^o
    //-----------------------------------------------*/
    ResultMessage(_T("Port B փf[^o (0x55)"));
    cbDat = (BYTE)0x55;           /* o̓f[^Zbg 0x55h */
    if ( ! Ud132OutPort( iDev, UD132_PORT_B, cbDat ) )
    {
        ErrorMessage(iDev);
        return 1;
    }
    wsprintf(szBuf, _T("o͊\n")
                    _T("Port B Out Data: %02xh"), cbDat);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // Port B 0x00̃f[^o
    //-----------------------------------------------*/
    ResultMessage(_T("Port B փf[^o (0x00)"));
    cbDat = (BYTE)0x00;         /* o̓f[^Zbg 0x00h */
    if ( ! Ud132OutPort( iDev, UD132_PORT_B, cbDat ) )
    {
        ErrorMessage(iDev);
        return 1;
    }
    wsprintf(szBuf, _T("o͊\n")
                    _T("Port B Out Data: %02xh"), cbDat);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // tB^̐ݒ
    //-----------------------------------------------*/
    ResultMessage(_T("̓|[gɑ΂ẴtB^ݒ"));

    bInterval = 0x01;           /* rC^[olf[^Zbg */
    bCount = 0x02;              /* vJE^lf[^Zbg */

    if ( ! Ud132SetFilter( iDev, bInterval, bCount) )
    {
        ErrorMessage(iDev);
        return 1;
    }

    wsprintf(szBuf, _T("tB^ݒ芮\n\n")
                    _T("rC^[ol = %u. (1260us)\n")
                    _T("vJE^l    = %u. (2)\n"),
                    bInterval,
                    bCount);

    ResultMessage(szBuf);

    ResultMessage(_T("tB^ݒ芮 : C^[o=1(1260us)AvJE^l=2(2)"));

    /*-------------------------------------------------
    // Port C f[^ǂݍ
    //-----------------------------------------------*/
    ResultMessage(_T("Port C ̓̓f[^̓ǂݍ"));
    if ( ! Ud132InPort( iDev, UD132_PORT_C, &cbDat ) )
    {
        ErrorMessage(iDev);
        return 1;
    }

    wsprintf(szBuf, _T("Port C ̓̓f[^\n")
                    _T("Port C In Data: %02xh"), cbDat);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // Port D f[^ǂݍ
    //-----------------------------------------------*/
    ResultMessage(_T("Port D ̓̓f[^̓ǂݍ"));
    if ( ! Ud132InPort( iDev, UD132_PORT_D, &cbDat ) )
    {
        ErrorMessage(iDev);
        return 1;
    }

    wsprintf(szBuf, _T("Port D ̓̓f[^\n")
                    _T("Port D In Data: %02xh"), cbDat);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // CPI-UD132̎gpJ
    //-----------------------------------------------*/
    if ( ! Ud132Close( iDev ) )
    {
        ErrorMessage( iDev );
        return 1;
    }
    ResultMessage(_T("CPI-UD132 Closed"));

    /*-------------------------------------------------
    // UD132.dll ̎gpJ
    //-----------------------------------------------*/
    if ( ! Ud132DllClose() )
    {
        ErrorMessage( iDev );
        return 1;
    }
    ResultMessage( _T( "DllClose succeeded.\n\n" ) );
    return 0;
}

/*============================================================================
// ʂ\
//===========================================================================*/
static void ResultMessage(LPCTSTR lpszbuf)
{
    MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

/*============================================================================
// G[bZ[W\
//===========================================================================*/
static void ErrorMessage(WORD iDev)
{

    ULONG   rd;
    TCHAR szBuf[50];

    rd = Ud132GetLastError( iDev );

    wsprintf(szBuf, _T("GetLastError\n\n")
        _T("Error code: %08lxh %s "),rd, str_err( rd ));
    MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
}

static  LPCTSTR str_err( ULONG iError )
{
    switch ( iError )
    {
    default:
        break;
    case UD132_SUCCESS:
        return _T( "Succeeded" );
    case UD132_ERR_SYSTEM:
        return _T( "System error occured" );
    case UD132_ERR_NO_DEVICE:
        return _T( "Device not found" );
    case UD132_ERR_IN_USE:
        return _T( "Device is in use" );
    case UD132_ERR_INVALID_DEVICENO:
        return _T( "Invalid device number" );
    case UD132_ERR_INVALID_ARGUMENT:
        return _T( "Invalid argument" );
    case UD132_ERR_INVALID_PORT:
        return _T( "Invalid port number" );
    case UD132_ERR_DLL:
        return _T( "DLL not opened" );
    case UD132_ERR_TRG_DATA_INVALID:
        return _T( "Data not accord" );
    }
    return _T( "Unknown error" );
}
