/*======================================================================
//  cpiud132.c
//
//  Copyright (C) CPI Technologies, Inc.
//====================================================================*/
#include <windows.h>
#include <tchar.h>
#include <assert.h>
#include "cpiud132.h"

/*======================================================================
// Macro
//====================================================================*/
#define SZ_DLL          _T( "CPIUD132.DLL" )

/*======================================================================
// Type
//====================================================================*/
typedef struct
{
            /*
            // NCAgĂяoGg
            // GetProcAddress ̃GgAɎsGg
            // ǂ炩ł
            */
    FARPROC         pfn;
    FARPROC const   pfnInv; /* ɎsGg */
    LPCSTR const    psz;    /* GNX|[g */
}   TFEE;
typedef struct
{
    TFEE    GetLastError;
    TFEE    GetVersion;
    TFEE    Create;
    TFEE    Close;
    TFEE    GetDevInfo;
    TFEE    GetSwitchValue;
    TFEE    GetUnitType;
    TFEE    InPort;
    TFEE    OutPort;
    TFEE    done;
    TFEE    init;
    TFEE    SetWdt;
    TFEE    ResetWdt;
    TFEE    SetDefaultOutput;
    TFEE    GetWdtStatus;
    TFEE    SetTrgCond;
    TFEE    SetFilter;
    TFEE    end_marker;         /* do NOT remove */
}   TDET;

/*======================================================================
// Statical function
//====================================================================*/
static  DWORD WINAPI InvGetLastError( WORD pwLogDevice );
static  INT_PTR WINAPI InvGetVersion( PDWORD pdwDllVersion, PDWORD pdwDriverVersion );

static  INT_PTR WINAPI InvCreate( PWORD pwLogDevice, HWND hwnd, UINT uWMCode );

static  INT_PTR WINAPI InvClose( WORD wLogDevice );
static  INT_PTR WINAPI InvGetDevInfo( WORD wLogDevice, PUD132DI pDevInfo );
static  INT_PTR WINAPI InvGetSwitchValue( WORD wLogDevice, PDWORD pdwSwitchValue );
static  INT_PTR WINAPI InvGetUnitType( WORD wLogDevice, PDWORD pdwUnitTypeValue );
static  INT_PTR WINAPI InvInPort( WORD wLogDevice, DWORD dwLogPort, PBYTE pbInValue );
static  INT_PTR WINAPI InvOutPort( WORD wLogDevice, DWORD dwLogPort, BYTE bOutValue );
static  INT_PTR WINAPI inv_done( void );
static  INT_PTR WINAPI inv_init( void );

static  INT_PTR WINAPI InvSetWdt( WORD wLogDevice, BYTE bWdtValue );
static  INT_PTR WINAPI InvResetWdt( WORD wLogDevice );
static  INT_PTR WINAPI InvSetDefaultOutput( WORD wLogDevice, DWORD dwLogPort, BYTE bDefaultValue );
static  INT_PTR WINAPI InvGetWdtStatus( WORD wLogDevice, PBYTE pbWdtStatus );

static  INT_PTR WINAPI InvSetTrgCond( WORD wLogDevice, DWORD dwLogPort, PUD132TC pTrgCond );
static  INT_PTR WINAPI InvSetFilter( WORD wLogDevice, BYTE bInterval, BYTE bCount );

static  BOOL det_get( void );
static  void det_inv( void );

/*======================================================================
// Statical variable
//====================================================================*/
static  HMODULE s_hDll = NULL;
static  TDET s_det =
{
{   ( FARPROC )InvGetLastError,
            ( FARPROC )InvGetLastError,
            "Ud132GetLastError"
            },
{   InvGetVersion,      InvGetVersion,      "Ud132GetVersion" },
{   InvCreate,          InvCreate,          "Ud132Create" },
{   InvClose,           InvClose,           "Ud132Close" },
{   InvGetDevInfo,      InvGetDevInfo,      "Ud132GetDevInfo" },
{   InvGetSwitchValue,  InvGetSwitchValue,  "Ud132GetSwitchValue" },
{   InvGetUnitType,     InvGetUnitType,     "Ud132GetUnitType" },
{   InvInPort,          InvInPort,          "Ud132InPort" },
{   InvOutPort,         InvOutPort,         "Ud132OutPort" },
{   inv_done,           inv_done,           "ud132_done" },
{   inv_init,           inv_init,           "ud132_init" },

{   InvSetWdt,          InvSetWdt,          "Ud132SetWdt" },
{   InvResetWdt,        InvResetWdt,        "Ud132ResetWdt" },
{   InvSetDefaultOutput,InvSetDefaultOutput,"Ud132SetDefaultOutput" },
{   InvGetWdtStatus,    InvGetWdtStatus,    "Ud132GetWdtStatus" },

{   InvSetTrgCond,      InvSetTrgCond,      "Ud132SetTrgCond" },
{   InvSetFilter,       InvSetFilter,       "Ud132SetFilter" },
{   NULL,               NULL,               NULL }
};

/*======================================================================
//      DLL [h
//      
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud132DllOpen( void )
{
    if ( NULL != s_hDll )
    {
        return TRUE;                    /* [hς݂͐ */
    }
    s_hDll = LoadLibrary( SZ_DLL );
    if ( NULL == s_hDll )
    {
        return FALSE;
    }
    if ( ! det_get() )
    {
        ( void )Ud132DllClose();
        return FALSE;
    }
    return TRUE;
}
/*======================================================================
//      DLL 
//      
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud132DllClose( void )
{
    if ( NULL == s_hDll )
    {
        return TRUE;                    /* Jς݂͐ */
    }

    det_inv();

    if ( ! FreeLibrary( s_hDll ) )
    {
        return FALSE;
    }

    s_hDll = NULL;

    return TRUE;
}
/*======================================================================
//      ŌɔG[̃R[h擾
//      iDev    G[foCX̘_foCXԍ
// ߂l   G[R[h
//====================================================================*/
DWORD WINAPI Ud132GetLastError( WORD pwLogDevice )
{
    assert( NULL != s_det.GetLastError.pfn );
    return ( DWORD )( *s_det.GetLastError.pfn )( pwLogDevice );
}
/*======================================================================
//      DLLAhCõo[Wԍ擾
//      pdwDllVersion
//                  DLL o[Wԍi[̈̃AhX
//          pdwDriverVersion
//                  hCoo[Wԍi[̈̃AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud132GetVersion( PDWORD pdwDllVersion, PDWORD pdwDriverVersion )
{
    assert( NULL != s_det.GetVersion.pfn );
    return ( BOOL )( *s_det.GetVersion.pfn )( pdwDllVersion, pdwDriverVersion );
}
/*======================================================================
//      Cӂ̃foCX̎gp錾
//      pwLogDevice gpfoCX̘_foCXԍi[AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud132Create( PWORD pwLogDevice, HWND hwnd, UINT uWMCode )
{
    assert( NULL != s_det.Create.pfn );
    return ( BOOL )( *s_det.Create.pfn )( pwLogDevice, hwnd, uWMCode );
}
/*======================================================================
//      gp̃foCX
//      wLogDevice  foCX̘_foCXԍ
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud132Close( WORD wLogDevice )
{
    assert( NULL != s_det.Close.pfn );
    return ( BOOL )( *s_det.Close.pfn )( wLogDevice );
}
/*======================================================================
//      wfoCX̃foCX擾
//      wLogDevice  foCX擾foCX̘_foCXԍ
//          pDevInfo    foCXi[\̂̃AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud132GetDevInfo( WORD wLogDevice, PUD132DI pDevInfo )
{
    assert( NULL != s_det.GetDevInfo.pfn );
    return ( BOOL )( *s_det.GetDevInfo.pfn )( wLogDevice, pDevInfo );
}
/*======================================================================
//      [^[XCb`̒l擾
//      wLogDevice      l擾foCX̘_foCXԍ
//          pdwSwitchValue  li[̈̃AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud132GetSwitchValue( WORD wLogDevice, PDWORD pdwSwitchValue )
{
    assert( NULL != s_det.GetSwitchValue.pfn );
    return ( BOOL )( *s_det.GetSwitchValue.pfn )( wLogDevice, pdwSwitchValue );
}
/*======================================================================
//      [^[XCb`̒l擾
//      wLogDevice      l擾foCX̘_foCXԍ
//          pdwSwitchValue  li[̈̃AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud132GetUnitType( WORD wLogDevice, PDWORD pdwUnitTypeValue )
{
    assert( NULL != s_det.GetUnitType.pfn );
    return ( BOOL )( *s_det.GetUnitType.pfn )( wLogDevice, pdwUnitTypeValue );
}
/*======================================================================
//      Cӂ̃|[gf[^
//      wLogDevice  ͂foCX̘_foCXԍ
//          dwLogPort   ͂_|[g
//          pbInValue   ̓f[^i[̈̃AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud132InPort( WORD wLogDevice, DWORD dwLogPort, PBYTE pbInValue )
{
    assert( NULL != s_det.InPort.pfn );
    return ( BOOL )( *s_det.InPort.pfn )( wLogDevice, dwLogPort, pbInValue );
}
/*======================================================================
//      Cӂ̃|[gփf[^o
//      wLogDevice  o͂foCX̘_foCXԍ
//          dwLogPort   o͂_|[g
//          bOutValue   o͂f[^
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud132OutPort( WORD wLogDevice, DWORD dwLogPort, BYTE bOutValue )
{
    assert( NULL != s_det.OutPort.pfn );
    return ( BOOL )( *s_det.OutPort.pfn )( wLogDevice, dwLogPort, bOutValue );
}

/*======================================================================
//      EIb`hbNJE^̐ݒ
//      wLogDevice    lݒ肷foCX̘_foCXԍ
//          dVal    JE^l (0`4)
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud132SetWdt( WORD wLogDevice, BYTE bWdtValue )
{
    assert( NULL != s_det.SetWdt.pfn );
    return ( BOOL )( *s_det.SetWdt.pfn )( wLogDevice, bWdtValue );
}

/*======================================================================
//      EIb`hbÑJE^Zbg
//      iDev    lݒ肷foCX̘_foCXԍ
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud132ResetWdt( WORD wLogDevice )
{
    assert( NULL != s_det.ResetWdt.pfn );
    return ( BOOL )( *s_det.ResetWdt.pfn )( wLogDevice );
}

/*======================================================================
//      EIb`hbNo͐ݒ
//      iDev    lݒ肷foCX̘_foCXԍ
//          dVal    JE^l (0`4)
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud132SetDefaultOutput( WORD wLogDevice, DWORD dwLogPort, BYTE bDefaultValue )
{
    assert( NULL != s_det.SetDefaultOutput.pfn );
    return ( BOOL )( *s_det.SetDefaultOutput.pfn )( wLogDevice, dwLogPort, bDefaultValue );
}

/*======================================================================
//      EIb`hbNtO擾
//      iDev    l擾foCX̘_foCXԍ
//          pbVal   EIb`hbNtOԂi[̈̃AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud132GetWdtStatus( WORD wLogDevice, PBYTE pbWdtStatus )
{
    assert( NULL != s_det.GetWdtStatus.pfn );
    return ( BOOL )( *s_det.GetWdtStatus.pfn )( wLogDevice, pbWdtStatus );
}

/*======================================================================
//      tB^l̐ݒ
//      iDev    lݒ肷foCX̘_foCXԍ
//          dVal    tB^lf[^(tB^[h[0],tB^}XN[1],tB^f[^[2])
// ߂l    TRUE
//          s FALSE
//====================================================================*/
//BOOL WINAPI Ud132SetTrgCond( WORD wLogDevice, DWORD dwLogPort, TUD132TC const* pTrgCond )
BOOL WINAPI Ud132SetTrgCond( WORD wLogDevice, DWORD dwLogPort, PUD132TC pTrgCond )
{
    assert( NULL != s_det.SetTrgCond.pfn );
    return ( BOOL )( *s_det.SetTrgCond.pfn )( wLogDevice, dwLogPort, pTrgCond );
}

/*======================================================================
//      tB^TCNAv񐔂̐ݒ
//      wLogDevice  lݒ肷foCX̘_foCXԍ
//          bInterval   tB^[TCNl
//              0: 21.33uS * 6 * 0UL        0mS  (~)
//              1: 21.33uS * 6 * 1000UL   128mS
//              2: 21.33uS * 6 * 2000UL   256mS 
//              3: 21.33uS * 6 * 3000UL   384mS 
//              4: 21.33uS * 6 * 8000UL   1024mS 
//              5: 21.33uS * 6 * 16000UL  2048mS 
//          bCount      v񐔁iCӁj
//
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud132SetFilter( WORD wLogDevice, BYTE bInterval, BYTE bCount )
{
    assert( NULL != s_det.SetFilter.pfn );
    return ( BOOL )( *s_det.SetFilter.pfn )( wLogDevice, bInterval, bCount);
}

/*----------------------------------------------------------------------
// ɎsGg
//--------------------------------------------------------------------*/
static  DWORD WINAPI InvGetLastError( WORD pwLogDevice )
{
    ( void )pwLogDevice;
    return UD132_ERR_DLL;
}
static  INT_PTR WINAPI InvGetVersion( PDWORD pdwDllVersion, PDWORD pdwDriverVersion )
{
    ( void )pdwDllVersion;
    ( void )pdwDriverVersion;
    return FALSE;
}
static  INT_PTR WINAPI InvCreate( PWORD pwLogDevice, HWND hwnd, UINT uWMCode  )
{
    ( void )pwLogDevice;
    ( void )hwnd;
    ( void )uWMCode;
    return FALSE;
}
static  INT_PTR WINAPI InvClose( WORD wLogDevice )
{
    ( void )wLogDevice;
    return FALSE;
}
static  INT_PTR WINAPI InvGetDevInfo( WORD wLogDevice, PUD132DI pDevInfo )
{
    ( void )wLogDevice;
    ( void )pDevInfo;
    return FALSE;
}
static  INT_PTR WINAPI InvGetSwitchValue( WORD wLogDevice, PDWORD pdwSwitchValue )
{
    ( void )wLogDevice;
    ( void )pdwSwitchValue;
    return FALSE;
}
static  INT_PTR WINAPI InvGetUnitType( WORD wLogDevice, PDWORD pdwUnitTypeValue )
{
    ( void )wLogDevice;
    ( void )pdwUnitTypeValue;
    return FALSE;
}
static  INT_PTR WINAPI InvInPort( WORD wLogDevice, DWORD dwLogPort, PBYTE pbInValue )
{
    ( void )wLogDevice;
    ( void )dwLogPort;
    ( void )pbInValue;
    return FALSE;
}
static  INT_PTR WINAPI InvOutPort(WORD wLogDevice, DWORD dwLogPort, BYTE bOutValue )
{
    ( void )wLogDevice;
    ( void )dwLogPort;
    ( void )bOutValue;
    return FALSE;
}
static  INT_PTR WINAPI inv_done( void )
{
    return FALSE;
}
static  INT_PTR WINAPI inv_init( void )
{
    return FALSE;
}
static  INT_PTR WINAPI InvSetWdt( WORD wLogDevice, BYTE bWdtValue )
{
    ( void )wLogDevice;
    ( void )bWdtValue;
    return FALSE;
}
static  INT_PTR WINAPI InvResetWdt( WORD wLogDevice )
{
    ( void )wLogDevice;
    return FALSE;
}
static  INT_PTR WINAPI InvSetDefaultOutput( WORD wLogDevice, DWORD dwLogPort, BYTE bDefaultValue )
{
    ( void )wLogDevice;
    ( void )dwLogPort;
    ( void )bDefaultValue;
    return FALSE;
}
static  INT_PTR WINAPI InvGetWdtStatus( WORD wLogDevice, PBYTE pbWdtStatus )
{
    ( void )wLogDevice;
    ( void )pbWdtStatus;
    return FALSE;
}

// static  INT_PTR WINAPI InvSetTrgCond( WORD wLogDevice, DWORD dwLogPort, TUD132TC const* pTrgCond )
static  INT_PTR WINAPI InvSetTrgCond( WORD wLogDevice, DWORD dwLogPort, PUD132TC  pTrgCond )
{
    ( void )wLogDevice;
    ( void )dwLogPort;
    ( void )pTrgCond;
    return FALSE;
}
static  INT_PTR WINAPI InvSetFilter( WORD wLogDevice, BYTE bInterval, BYTE bCount )
{
    ( void )wLogDevice;
    ( void )bInterval;
    ( void )bCount;
    return FALSE;
}

/*----------------------------------------------------------------------
//      Gg擾
//      
// ߂l    TRUE
//          s FALSE
//--------------------------------------------------------------------*/
static  BOOL det_get( void )
{
    TFEE*   pfe;

    for ( pfe = ( TFEE* )&s_det; NULL != pfe->psz; pfe++ )
    {
        pfe->pfn = GetProcAddress( s_hDll, pfe->psz );
        if ( NULL == pfe->pfn )
        {
            pfe->pfn = pfe->pfnInv;

            return FALSE;
        }
    }

    assert( NULL != s_det.init.pfn );

    return ( BOOL )( *s_det.init.pfn )();
}
/*----------------------------------------------------------------------
//      Gg
//      
// ߂l    TRUE
//          s FALSE
//--------------------------------------------------------------------*/
static  void det_inv( void )
{
    TFEE*   pfe;

    assert( NULL != s_det.done.pfn );
    ( void )( *s_det.done.pfn )();

    for ( pfe = ( TFEE* )&s_det; NULL != pfe->psz; pfe++ )
    {
        pfe->pfn = pfe->pfnInv;
    }
}
